from sqlalchemy import String, Column, DateTime, Float, Integer, ForeignKey
from sqlalchemy.orm import relationship
from .sap_model import SapBonanzaBase as SBB

class OrdemCitas(SBB):
    __tablename__ = 'sap_ordem_citas'

    DocNum = Column('DocNum', Integer, primary_key=True)
    Period = Column('Period', Integer)
    Instance = Column('Instance', Integer)
    Series = Column('Series', Integer)
    Handwrtten = Column('Handwrtten', String)
    Status = Column('Status', String)
    RequestStatus = Column('RequestStatus', String)
    Creator = Column('Creator', String)
    Remark = Column('Remark', String, nullable=True)
    DocEntry = Column('DocEntry', Integer)
    Canceled = Column('Canceled', String)
    Object = Column('Object', String)
    LogInst = Column('LogInst', String, nullable=True)
    UserSign = Column('UserSign', Integer)
    Transfered = Column('Transfered', String)
    CreateDate = Column('CreateDate', DateTime)
    CreateTime = Column('CreateTime', String)
    UpdateDate = Column('UpdateDate', DateTime, nullable=True)
    UpdateTime = Column('UpdateTime', String, nullable=True)
    DataSource = Column('DataSource', String)
    U_NumCita = Column('U_NumCita', String)
    U_Num_Cot = Column('U_Num_Cot', String)
    U_FechaCita = Column('U_FechaCita', DateTime)
    U_HoraCita = Column('U_HoraCita', String)
    U_Cod_Sucursal = Column('U_Cod_Sucursal', String)
    U_Cod_Agenda = Column('U_Cod_Agenda', String)
    U_Cod_Razon = Column('U_Cod_Razon', String)
    U_Estado = Column('U_Estado', String)
    U_Cod_Asesor = Column('U_Cod_Asesor', String)
    U_Cod_Tecnico = Column('U_Cod_Tecnico', String)
    U_CardCode = Column('U_CardCode', String)
    U_Cod_Unid = Column('U_Cod_Unid', String)
    U_CreadoPor = Column('U_CreadoPor', String, nullable=True)
    U_FhaSync = Column('U_FhaSync', String, nullable=True)
    U_UsaArt = Column('U_UsaArt', String)
    U_Num_Serie = Column('U_Num_Serie', String)
    U_Name_Asesor = Column('U_Name_Asesor', String)
    U_Name_Tecnico = Column('U_Name_Tecnico', String, nullable=True)
    U_CardName = Column('U_CardName', String)
    U_CpnNo = Column('U_CpnNo', String, nullable=True)
    U_CpnName = Column('U_CpnName', String)
    U_Moneda = Column('U_Moneda', String)
    U_TipoC = Column('U_TipoC', Float)
    U_Total_Doc = Column('U_Total_Doc', Float)
    U_Total_Imp = Column('U_Total_Imp', Float)
    U_Total_Lin = Column('U_Total_Lin', Float)
    U_FhaCita_Fin = Column('U_FhaCita_Fin', DateTime)
    U_HoraCita_Fin = Column('U_HoraCita_Fin', String)
    U_Num_Placa = Column('U_Num_Placa', String)
    U_Observ = Column('U_Observ', String)
    U_FhaServ = Column('U_FhaServ', DateTime, nullable=True)
    U_HoraServ = Column('U_HoraServ', String, nullable=True)
    U_FhaServ_Fin = Column('U_FhaServ_Fin', DateTime, nullable=True)
    U_HoraServ_Fin = Column('U_HoraServ_Fin', String, nullable=True)
    U_CodVehi = Column('U_CodVehi', Integer)
    U_NCliOT = Column('U_NCliOT', String)
    U_CCliOT = Column('U_CCliOT', String)
    U_MCancelacion = Column('U_MCancelacion', String, nullable=True)
    U_CCancelacion = Column('U_CCancelacion', String, nullable=True)
    U_Retiro = Column('U_Retiro', String, nullable=True)
    U_CRetiro = Column('U_CRetiro', String, nullable=True)
    U_Entrega = Column('U_Entrega', String, nullable=True)
    U_CEntrega = Column('U_CEntrega', String, nullable=True)
    U_Movilidad = Column('U_Movilidad', String, nullable=True)
    U_CMovilidad = Column('U_CMovilidad', String, nullable=True)
    U_Contacto = Column('U_Contacto', String, nullable=True)
    U_Campana = Column('U_Campana', String, nullable=True)
    U_Garantia = Column('U_Garantia', String, nullable=True)
    U_UsrAnonimo = Column('U_UsrAnonimo', String)
    U_CliTel = Column('U_CliTel', String, nullable=True)
    U_CliEmail = Column('U_CliEmail', String, nullable=True)
    U_VehPlaca = Column('U_VehPlaca', String, nullable=True)
    U_UpdateBy = Column('U_UpdateBy', String, nullable=True)
    U_CContacto = Column('U_CContacto', String, nullable=True)
    U_Overbook = Column('U_Overbook', String, nullable=True)
    U_Towing = Column('U_Towing', String, nullable=True)
    U_CliCel = Column('U_CliCel', String, nullable=True)
    U_Cod_Marc = Column('U_Cod_Marc', String, nullable=True)
    U_Des_Marc = Column('U_Des_Marc', String, nullable=True)
    U_Cod_Esti = Column('U_Cod_Esti', String, nullable=True)
    U_Des_Esti = Column('U_Des_Esti', String, nullable=True)
    U_Cod_Mode = Column('U_Cod_Mode', String, nullable=True)
    U_Des_Mode = Column('U_Des_Mode', String, nullable=True)
    U_ComentariosGeneralesCIT_OT = Column('U_ComentariosGeneralesCIT_OT', String, nullable=True)
    U_TAdicional = Column('U_TAdicional', Float)

    def __repr__(self):
        return f"<OrdemCitas(DocNum='{self.DocNum}', U_NumCita='{self.U_NumCita}')>"
